<template>
  <div class="grid grid--battle">
    <div class="flex picked">
      <base-button
        :class="['btn', { ripple: result == 1 }, choice]"
        :type="choice"
      ></base-button>
      <h2 class="text-animation">you picked</h2>
    </div>
    <div class="flex cpu-picked fade-in">
      <base-button
        :class="['btn', { ripple: result == -1 }, cpuChoice]"
        :type="cpuChoice"
      ></base-button>
      <h2 class="text-animation">the house picked</h2>
    </div>
    <div class="flex result">
      <h2 class="text-animation-slower">
        <span v-if="result == 0">draw</span>
        <span v-else-if="result == 1">you win</span>
        <span v-else>you lose</span>
      </h2>
      <button @click="playAgain" class="btn-play">play again</button>
    </div>
  </div>
</template>

<script>
export default {
  emits: ["get-result", "play-again"],
  props: ["choice"],
  data() {
    return {
      cpuChoice: null,
      result: null,
    };
  },
  created() {
    this.cpuChoice = this.getCpuChoice();
    this.result = this.getResultGame(this.choice, this.cpuChoice);
    this.$emit("get-result", this.result);
  },
  methods: {
    getCpuChoice() {
      const games = ["spock", "lizard", "rock", "paper", "scissors"];
      const random = Math.floor(Math.random() * games.length);
      return games[random];
    },
    getResultGame(choice, cpuChoice) {
      if (choice == cpuChoice) {
        return 0;
      } else if (
        choice == "scissors" &&
        (cpuChoice == "paper" || cpuChoice == "lizard")
      ) {
        return 1;
      } else if (
        choice == "paper" &&
        (cpuChoice == "rock" || cpuChoice == "spock")
      ) {
        return 1;
      } else if (
        choice == "rock" &&
        (cpuChoice == "lizard" || cpuChoice == "scissors")
      ) {
        return 1;
      } else if (
        choice == "lizard" &&
        (cpuChoice == "spock" || cpuChoice == "paper")
      ) {
        return 1;
      } else if (
        choice == "spock" &&
        (cpuChoice == "rock" || cpuChoice == "scissors")
      ) {
        return 1;
      } else {
        return -1;
      }
    },
    playAgain() {
      this.$emit("play-again");
    },
  },
};
</script>

<style scoped>
.grid--battle {
  --gap: 0;
  column-gap: 1rem;
  width: 100%;
  place-content: center;
  margin-inline: auto;
  grid-template-columns: repeat(2, 1fr);
  grid-template-areas:
    "picked cpu-picked"
    "result  result";
  margin-top: 1rem;
}
@media (min-width: 56.25em) {
  .grid--battle {
    max-width: 65rem;
    grid-template-columns: 1fr max-content 1fr;
    grid-template-areas: "picked result cpu-picked";
  }
}

.picked > h2,
.cpu-picked > h2 {
  text-transform: uppercase;
  font-size: 0.9375rem;
  letter-spacing: 0.125rem;
  font-weight: var(--fw-600);
}
@media (min-width: 56.25em) {
  .picked > h2,
  .cpu-picked > h2 {
    font-size: 1.5rem;
    letter-spacing: 0.1875rem;
  }
}

.picked {
  gap: 2rem;
  grid-area: picked;
  flex-direction: column;
}
.cpu-picked {
  gap: 2rem;
  grid-area: cpu-picked;
  flex-direction: column;
}
.result {
  text-transform: uppercase;
  flex-direction: column;
  grid-area: result;
  font-size: 3rem;
}
@media (min-width: 56.25em) {
  .picked,
  .cpu-picked {
    flex-direction: column-reverse;
  }
  .result {
    align-self: center;
  }
}
.text-animation {
  animation: fadeInText 1s 1s cubic-bezier(0.175, 0.885, 0.32, 1.275) both;
}
.text-animation-slower {
  animation: fadeInText 2s 2s cubic-bezier(0.175, 0.885, 0.32, 1.275) both;
}

.btn-play {
  cursor: pointer;
  width: 13.75rem;
  height: 3.125rem;
  max-width: 100%;
  border-radius: 0.4375rem;
  color: var(--neutral-dark);
  background-color: var(--neutral-white);
  font-size: 0.875rem;
  text-transform: uppercase;
  letter-spacing: 0.125rem;
  margin-top: 14px;
  border: none;
  margin-bottom: 1rem;
}
.btn-play:hover {
  color: #dc2e4e;
}
@media (min-width: 56.25em) {
  .btn {
    width: 15rem;
    height: 15rem;
  }
  .icon {
    width: 55%;
    height: 55%;
  }
}
.ripple {
  animation: ripple 3s linear infinite;
}

.ripple::before,
.ripple::after {
  border-radius: 50%;
  animation: inherit;
  animation-delay: 1s;
}
.ripple::after {
  animation-delay: 2s;
}
.fade-in {
  animation: fadeIn ease-in 1s;
}
@keyframes fadeIn {
  0% {
    opacity: 0;
    transform: scale(0);
  }
  100% {
    opacity: 1;
    transform: scale(1);
  }
}
@keyframes ripple {
  0% {
    box-shadow: 0 0 0 0.7rem hsla(0, 0%, 30%, 0.1);
  }
  100% {
    box-shadow: 0 0 0 6rem hsla(0, 0%, 40%, 0.1);
  }
}

@keyframes fadeInText {
  from {
    font-size: 0;
  }
}
</style>
